--------------------------------------------
-- @Author  : htp
-- @Editor  : htp
-- @Date    : 2019-01-10 10:56:54
-- @description    : 
		-- 基金主界面
---------------------------------
ActionFundMainWindow = ActionFundMainWindow or BaseClass(BaseView)

local _controller = ActionController:getInstance() 
local _model = ActionController:getInstance():getModel()
local role_vo = RoleController:getInstance():getRoleVo()

function ActionFundMainWindow:__init(ctrl)
    self.is_full_screen = true
    self.win_type = WinType.Full
    --self.layout_name = "welfare/welfare_main_view"
    self.layout_name = "action/gw_action_fund_main_window"

    self.res_list = {
        --{ path = PathTool.getPlistImgForDownLoad("bigbg/welfare","welfare_bg"), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("bigbg/welfare","welfare_bg_1"), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("bigbg/welfare","welfare_tab"), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("bigbg/action","txt_cn_action_fund_bg_1",true), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("bigbg/action","txt_cn_action_fund_bg_2",true), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("welfare","welfare"), type = ResourcesType.plist },
        --{ path = PathTool.getPlistImgForDownLoad("welfaretab","welfaretab"), type = ResourcesType.plist},
        --{ path = PathTool.getPlistImgForDownLoad("actionfund","actionfund"), type = ResourcesType.plist },
        { path = PathTool.getPlistImgForDownLoad("gw_action_fund","gw_action_fund"), type = ResourcesType.plist },
        { path = PathTool.getPlistImgForDownLoad("gw_action_fund","gw_action_fund_02", true), type = ResourcesType.single },
    }

    self.panel_list = {}
    self.tab_list = {}
    self.tab_width = 78
    self.off_space = 50
    self.selected_tab = nil
end

function ActionFundMainWindow:open_callback(  )
    self.left_top_container = self.root_wnd:getChildByName("left_top_container")
    self.left_top_container:setPositionX(display.getLeft())
    self.left_top_container:setPositionY(display.getTop())
    self.right_top_container = self.root_wnd:getChildByName("right_top_container")
    self.right_top_container:setPositionX(display.getRight())
    self.right_top_container:setPositionY(display.getTop())
    self.bottom_container = self.root_wnd:getChildByName("bottom_container")
    self.bottom_container:setPositionY(display.getBottom())
    self.bottom_bg = self.bottom_container:getChildByName("bg")
    self.bottom_bg:setContentSize(cc.size(display.width, 120))

    self.sheet_left_btn = self.bottom_container:getChildByName("left_btn")
    self.sheet_left_btn:setPositionX(display.getLeft() + 22)
    self.sheet_left_btn:setVisible(false)
    self.sheet_left_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            local list_view_width = self.sheet_list_view:getContentSize().width
            local list_view_inner_width = self.sheet_list_view.scroll_view:getInnerContainer():getContentSize().width
            if list_view_inner_width <= list_view_width then return end

            local cur_pos = self.sheet_list_view.scroll_view:getInnerContainer():getPositionX()

            if cur_pos >= 0 then
                return
            end

            self.sheet_list_view.container:stopAllActions()

            playButtonSound2()
            local end_pos = cur_pos + GW_GuildSkillMainWindowTabItem.Width
            if end_pos > 0 then
                end_pos = 0
            end

            local move_to = cc.MoveTo:create(0.1, cc.p(end_pos, self.sheet_list_view.scroll_view:getInnerContainer():getPositionY()))
            self.sheet_list_view.container:runAction(cc.Sequence:create(move_to, cc.CallFunc:create(function()
                self.sheet_list_view:checkRectIntersectsRect()
            end)))
        end
    end)
    self.sheet_right_btn = self.bottom_container:getChildByName("right_btn")
    self.sheet_right_btn:setPositionX(display.getRight() - 22)
    self.sheet_right_btn:setVisible(false)
    self.sheet_right_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            local list_view_width = self.sheet_list_view:getContentSize().width
            local list_view_inner_width = self.sheet_list_view.scroll_view:getInnerContainer():getContentSize().width
            if list_view_inner_width <= list_view_width then return end

            local min_end_pos = list_view_width - list_view_inner_width

            local cur_pos = self.sheet_list_view.scroll_view:getInnerContainer():getPositionX()
            if cur_pos <= min_end_pos then
                return
            end

            self.sheet_list_view.container:stopAllActions()

            playButtonSound2()
            local end_pos = cur_pos - GW_GuildSkillMainWindowTabItem.Width
            if cur_pos < min_end_pos then
                end_pos = min_end_pos
            end

            local move_to = cc.MoveTo:create(0.1, cc.p(end_pos, self.sheet_list_view.scroll_view:getInnerContainer():getPositionY()))
            self.sheet_list_view.container:runAction(cc.Sequence:create(move_to, cc.CallFunc:create(function()
                self.sheet_list_view:checkRectIntersectsRect()
            end)))

            --self.sheet_list_view:jumpToMove(cc.p(end_pos, self.sheet_list_view.scroll_view:getInnerContainer():getPositionY()), 0.1)
        end
    end)

    --背景
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())
    local bg_res = PathTool.getPlistImgForDownLoad("gw_action_fund", "gw_action_fund_02", true)
    self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)

    --返回上一级
    self.back_btn = self.left_top_container:getChildByName("back_btn")
    self.back_btn:getChildByName("label"):setString(UI_TI18N(10000002))
    self.back_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            _controller:openActionFundWindow(false)
        end
    end)
    --返回主城
    self.home_btn = self.right_top_container:getChildByName("home_btn")
    self.home_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            BackToHome()
        end
    end)

    --上方资产
    self.top_num_wealth_list = {}
    for i=1,3 do
        self.top_num_wealth_list[i] = {}
        if i==1 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("gold_info")
        elseif i==2 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("diamond_info")
        else
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("hero_exp_info")
        end
        self.top_num_wealth_list[i].icon = self.top_num_wealth_list[i].btn:getChildByName("icon")
        self.top_num_wealth_list[i].value = self.top_num_wealth_list[i].btn:getChildByName("label")
    end
    self.top_num_wealth_list[3].btn:setVisible(false)
    self.coin_redpoint = self.top_num_wealth_list[2].btn:getChildByName("add")

    self.sheet_container = self.bottom_container:getChildByName("sheet_container")
    self.sheet_container:setPositionX(display.getLeft())
    self.sheet_container:setContentSize(cc.size(display.width, 90))
    local setting = {
        -- item_class = GW_RoleHeroDrawListItem,      -- 单元类
        start_x = 0,                  -- 第一个单元的X起点
        space_x = 0,                    -- x方向的间隔
        start_y = 18,                    -- 第一个单元的Y起点
        space_y = 0,                   -- y方向的间隔
        item_width = 250,               -- 单元的尺寸width
        item_height = 76,              -- 单元的尺寸height
        row = 1,                        -- 行数，作用于水平滚动类型
        col = 1,                         -- 列数，作用于垂直滚动类型
        need_dynamic = true
    }
    local size = self.sheet_container:getContentSize()
    self.sheet_list_view = CommonScrollViewSingleLayout.new(self.sheet_container, cc.p(0, 0) , ScrollViewDir.horizontal, ScrollViewStartPos.top, size, setting, cc.p(0,0))
    self.sheet_list_view:registerScriptHandlerSingle(handler(self,self.sheet_createNewCell), ScrollViewFuncType.CreateNewCell) --创建cell
    self.sheet_list_view:registerScriptHandlerSingle(handler(self,self.sheet_numberOfCells), ScrollViewFuncType.NumberOfCells) --获取数量
    self.sheet_list_view:registerScriptHandlerSingle(handler(self,self.sheet_updateCellByIndex), ScrollViewFuncType.UpdateCellByIndex) --更新cell


    self.panel_container = self.root_wnd:getChildByName("panel_container")



    --self.background = self.root_wnd:getChildByName("background")
    --if self.background ~= nil then
    --    loadSpriteTexture(self.background, PathTool.getPlistImgForDownLoad("bigbg/welfare","welfare_bg"), LOADTEXT_TYPE)
    --    self.background:setScale(display.getMaxScale())
    --end
    --self.main_container = self.root_wnd:getChildByName("main_container")
    --self.main_container:setPositionY(display.getTop()-196)
    --
    --local main_panel = self.main_container:getChildByName("main_panel")
    --self.container = main_panel:getChildByName("container")
    --self.tab_sprite_bg = main_panel:getChildByName("tab_sprite_bg")
    --loadSpriteTexture(self.tab_sprite_bg, PathTool.getPlistImgForDownLoad("bigbg/welfare","welfare_bg_1"), LOADTEXT_TYPE)
    --
    --local tab_container = self.root_wnd:getChildByName("tab_container")
    --self.close_btn = tab_container:getChildByName("close_btn")
    ----local bottom_height = MainuiController:getInstance():getMainUi():getBottomHeight()
    ----self.close_btn:setPositionY(display.getBottom()+bottom_height+25)
    --
    --local scroll_container = self.root_wnd:getChildByName("scroll_container")
    --local sprite_tab = scroll_container:getChildByName("sprite_tab")
    --loadSpriteTexture(sprite_tab, PathTool.getPlistImgForDownLoad("bigbg/welfare","welfare_tab"), LOADTEXT_TYPE)
    --
    --scroll_container:setPositionY(display.getTop())
    --local top_sprite1 = scroll_container:getChildByName("top_sprite1")
    --top_sprite1:setLocalZOrder(10)
    --local top_sprite2 = scroll_container:getChildByName("top_sprite2")
    --top_sprite2:setLocalZOrder(10)
    --self.tab_scroll = createScrollView(scroll_container:getContentSize().width,scroll_container:getContentSize().height,0,0,scroll_container,ccui.ScrollViewDir.horizontal)
end

function ActionFundMainWindow:register_event(  )
	--registerButtonEventListener(self.close_btn, function()
    --    _controller:openActionFundWindow(false)
    --end, true, 2)

    self:addGlobalEvent(ActionEvent.UPDATA_FUND_ID_LIST_EVENT, function( )
        self:updateTabBtns()
    end)

    self:addGlobalEvent(ActionEvent.UPDATA_FUND_RED_STATUS_EVENT, function( )
        self:updateTabRedStatus()
    end)


    if role_vo then
        if self.role_update_event == nil then
            self.role_update_event = role_vo:Bind(RoleEvent.UPDATE_ROLE_ATTRIBUTE, function(key, value)
                if key == "coin" or key == "gold" or key == "red_gold" or key == "silver_coin" or key == "guild" then
                    self:updateTopNumWealth()
                end
            end)
        end
    end
    self.top_num_wealth_list[1].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
        end
    end)
    self.top_num_wealth_list[2].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ExchangeController:getInstance():openExchangeMainView(true)
        end
    end)
    --self.top_num_wealth_list[3].btn:addTouchEventListener(function(sender, event_type)
    --    customClickAction(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        local config = Config.ItemData.data_get_data(Config.ItemData.data_assets_label2id.guild)
    --        if config then
    --            BackpackController:getInstance():openTipsSource(true, config)
    --        end
    --        --if self.gw_skill_type == GuildskillConst.gw_skill_type.normal then
    --        --    local config = Config.ItemData.data_get_data(Config.ItemData.data_assets_label2id.guild)
    --        --    if config then
    --        --        BackpackController:getInstance():openTipsSource(true, config)
    --        --    end
    --        --else
    --        --
    --        --end
    --    end
    --end)
    --点金红点
    if self.coin_touch_redpoint == nil then
        self.coin_touch_redpoint = GlobalEvent:getInstance():Bind(ExchangeEvent.Extra_Reward, function(data)
            self.exchange_data = data
            self:updataExchangeRedPoint()
        end)
    end

end

function ActionFundMainWindow:openRootWnd( fund_type )
    ExchangeController:getInstance():send23606()
    self:updateTopNumWealth()

    if fund_type == nil then
        local type_one_status = _model:getFundRedStatusByBid(FundRedIndex.fund_get_one)
        if not type_one_status then
            type_one_status = _model:getFundRedStatusByBid(FundRedIndex.fund_buy_one)
        end

        if type_one_status == false then
            local type_two_status = _model:getFundRedStatusByBid(FundRedIndex.fund_get_two)
            if not type_two_status then
                type_two_status = _model:getFundRedStatusByBid(FundRedIndex.fund_buy_two)
            end

            if type_two_status == true then
                fund_type = FundType.type_two
            end
        end
    end

    self.fund_type = fund_type or FundType.type_one
    self.action_bid = self.fund_type
    self:updateTabBtns()
end

function ActionFundMainWindow:updateTabBtns(  )
    self.sub_list = {}

    local fund_id_list = _model:getOpenFundIds()
    for k,v in pairs(fund_id_list) do
        local config = Config.MonthFundData.data_fund_data[v.id]
        if config then
            local sub_data = {}
            sub_data.bid = v.id
            sub_data.title = config.name
            sub_data.ico = config.icon_id
            table.insert(self.sub_list, sub_data)
        end
    end
    table.sort(self.sub_list, SortTools.KeyLowerSorter("bid"))
    self:createSubType()
    self:updateTabRedStatus()
end

function ActionFundMainWindow:createSubType(  )
    if self.sub_list == nil or next(self.sub_list) == nil then
        return
    end

    local sum = #self.sub_list
    local total_width = sum * GW_GuildSkillMainWindowTabItem.Width

    self.sheet_index = nil
    self.sheet_list_data = {}
    for i=1,sum do
        self.sheet_list_data[i] = {}
        self.sheet_list_data[i].sheet_index = i
        self.sheet_list_data[i].data = self.sub_list[i]
        self.sheet_list_data[i].desc = self.sub_list[i].title
        if self.sheet_list_data[i].data.bid == self.action_bid then
            self.sheet_list_data[i].select = true
            self.sheet_index = i
        else
            self.sheet_list_data[i].select = false
        end
        self.sheet_list_data[i].is_end = false

        local status = false
        if self.sub_list[i].bid == FundType.type_one then
            status = _model:getFundRedStatusByBid(FundRedIndex.fund_get_one)
            if not status then
                status = _model:getFundRedStatusByBid(FundRedIndex.fund_buy_one)
            end
        elseif self.sub_list[i].bid == FundType.type_two then
            status = _model:getFundRedStatusByBid(FundRedIndex.fund_get_two)
            if not status then
                status = _model:getFundRedStatusByBid(FundRedIndex.fund_buy_two)
            end
        end
        self.sheet_list_data[i].red_point = status
    end
    if self.sheet_index == nil then
        self.sheet_index = #self.sheet_list_data
        self.sheet_list_data[self.sheet_index].select = true
    end
    self.sheet_list_data[1].show_start_line = (total_width < display.width)
    self.sheet_list_data[sum].is_end = true

    self.sheet_list_view:reloadData()
    if total_width > display.width then
        self.sheet_list_view:setPositionX(display.getLeft())
        self.sheet_list_view.scroll_view:setContentSize(cc.size(display.width, 90))
        self.sheet_list_view.scroll_view:setInnerContainerSize(cc.size(total_width, 90))
        self.sheet_left_btn:setVisible(true)
        self.sheet_right_btn:setVisible(true)
        if self.sheet_index >= (#self.sheet_list_data/2) then
            self.sheet_list_view.scroll_view:jumpToRight()
        else
            self.sheet_list_view.scroll_view:jumpToLeft()
        end
        self.sheet_list_view.scroll_view:setTouchEnabled(true)

    else
        self.sheet_list_view:setPositionX(display.getRight() - total_width)
        self.sheet_list_view.scroll_view:setContentSize(cc.size(total_width, 90))
        self.sheet_list_view.scroll_view:setInnerContainerSize(cc.size(total_width, 90))
        self.sheet_left_btn:setVisible(false)
        self.sheet_right_btn:setVisible(false)
        self.sheet_list_view.scroll_view:jumpToLeft()
        self.sheet_list_view.scroll_view:setTouchEnabled(false)
    end


    local data = self.sheet_list_data[self.sheet_index].data
    if data and data.bid then
        -- 点击标签页之后购买红点消失
        if data.bid == FundType.type_one then
            _model:updateFundRedStatus(FundRedIndex.fund_buy_one, false)
        elseif data.bid == FundType.type_two then
            _model:updateFundRedStatus(FundRedIndex.fund_buy_two, false)
        end
    end

    self:changePanelByTab()

	--if self.sub_list == nil or next(self.sub_list) == nil then
	--	return
	--end
    --
    --for k,v in pairs(self.tab_list) do
    --    v:setVisible(false)
    --end
    --
    --local sum = #self.sub_list
    --local max_width = sum * (self.tab_width + self.off_space) + self.off_space
    --self.max_width = math.max(self.tab_scroll:getContentSize().width,max_width)
    --self.tab_scroll:setInnerContainerSize(cc.size(self.max_width,self.tab_scroll:getContentSize().height))
    --
    --local function call_back(item)
    --    self:handleSelectedTab(item)
    --end
    --local index_selected = 0
    --local tab_item, _x, _y, data = nil, 2
    --for i=1,sum do
    --    data = self.sub_list[i]
    --    if data ~= nil and data.bid ~= nil and self.tab_list[data.bid] == nil then
    --        tab_item = WelfareTab.new()
    --        tab_item:setData(data)
    --        _x = self.off_space+(i-1)*(self.tab_width+self.off_space)
    --        tab_item:setPosition(_x,79)
    --        tab_item:setClickCallBack(call_back)
    --        self.tab_scroll:addChild(tab_item)
    --        self.tab_list[data.bid] = tab_item
    --        if self.fund_type ~= nil then
    --            if self.fund_type == data.bid then
    --                index_selected = i
    --            end
    --        end
    --    end
    --    if tab_item then
    --        tab_item:setVisible(true)
    --    end
    --end
    --
    --if index_selected == 0 then
    --    index_selected = 1
    --end
    ---- 手动设置选中第一个
    --data = self.sub_list[index_selected]
    --if data ~= nil then
    --    self:handleSelectedTab(self.tab_list[data.bid])
    --end
end

function ActionFundMainWindow:handleSelectedTab( tab )
	if self.selected_tab ~= nil and self.selected_tab == tab then return end

    if self.selected_tab ~= nil then
        self.selected_tab:setSelecte(false)
    end
    self.selected_tab = tab
    if self.selected_tab ~= nil then
        self.selected_tab:setSelecte(true)
    end

    local data = self.selected_tab.data
    if data and data.bid then
        -- 点击标签页之后购买红点消失
        if data.bid == FundType.type_one then
            _model:updateFundRedStatus(FundRedIndex.fund_buy_one, false)
        elseif data.bid == FundType.type_two then
            _model:updateFundRedStatus(FundRedIndex.fund_buy_two, false)
        end
    end

    self:changePanelByTab()
end

function ActionFundMainWindow:changePanelByTab(  )
    if self.sheet_index == nil then return end
    if self.sheet_list_data == nil then return end
    if self.sheet_list_data[self.sheet_index] == nil then return end

    local data = self.sheet_list_data[self.sheet_index].data
    if data == nil then return end
    if data.bid == nil or data.bid == 0 then return end



	--if self.selected_tab == nil or self.selected_tab.data == nil then return end
    --local data = self.selected_tab.data
    --if data.bid == nil or data.bid == 0 then return end


    if self.selected_panel ~= nil then
        if self.selected_panel.setVisibleStatus then
            self.selected_panel:setVisibleStatus(false)
        else
            self.selected_panel:setVisible(false)
        end
        self.selected_panel = nil
    end

    if self.panel_list[data.bid] == nil then
        local panel_view
        if data.bid == FundType.type_one then
            panel_view = ActionFundOnePanel.new(data.bid)
        elseif data.bid == FundType.type_two then
            panel_view = ActionFundTwoPanel.new(data.bid)
        end
        if panel_view then
            self.panel_list[data.bid] = panel_view
            self.panel_container:addChild(panel_view)
        end
    end
    self.selected_panel = self.panel_list[data.bid]
    
    if self.selected_panel then
        if self.selected_panel.setVisibleStatus then
            self.selected_panel:setVisibleStatus(true)
        else
            self.selected_panel:setVisible(true)
        end
    end
end

-- 更新标签页红点显示
function ActionFundMainWindow:updateTabRedStatus( )
    if self.sheet_list_data == nil or next(self.sheet_list_data) == nil then return end

    for i,v in pairs(self.sheet_list_data) do
        local status = false
        if v.data.bid == FundType.type_one then
            status = _model:getFundRedStatusByBid(FundRedIndex.fund_get_one)
            if not status then
                status = _model:getFundRedStatusByBid(FundRedIndex.fund_buy_one)
            end
        elseif v.data.bid == FundType.type_two then
            status = _model:getFundRedStatusByBid(FundRedIndex.fund_get_two)
            if not status then
                status = _model:getFundRedStatusByBid(FundRedIndex.fund_buy_two)
            end
        end

        v.red_point = status
    end
    self.sheet_list_view:resetCurrentItems()

    --for bid,tab_item in pairs(self.tab_list) do
    --    local status = false
    --    if bid == FundType.type_one then
    --        status = _model:getFundRedStatusByBid(FundRedIndex.fund_get_one)
    --        if not status then
    --            status = _model:getFundRedStatusByBid(FundRedIndex.fund_buy_one)
    --        end
    --    elseif bid == FundType.type_two then
    --        status = _model:getFundRedStatusByBid(FundRedIndex.fund_get_two)
    --        if not status then
    --            status = _model:getFundRedStatusByBid(FundRedIndex.fund_buy_two)
    --        end
    --    end
    --    if tab_item.updateTipsStatus then
    --        tab_item:updateTipsStatus(status)
    --    end
    --end
end

function ActionFundMainWindow:close_callback()
    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end
    self.sheet_index = nil
    if self.sheet_list_view ~= nil then
        self.sheet_list_view:DeleteMe()
        self.sheet_list_view = nil
    end
    self.top_num_wealth_list = nil
    if self.role_update_event then
        GlobalEvent:getInstance():UnBind(self.role_update_event)
        self.role_update_event = nil
    end

    self.exchange_data = nil
    if self.coin_redpoint_spine ~= nil then
        self.coin_redpoint_spine:clearTracks()
        self.coin_redpoint_spine:removeFromParent()
        self.coin_redpoint_spine = nil
    end
    if self.coin_touch_redpoint then
        GlobalEvent:getInstance():UnBind(self.coin_touch_redpoint)
        self.coin_touch_redpoint = nil
    end

	for k,v in pairs(self.panel_list) do
        if v.DeleteMe then
            v:DeleteMe()
        end
    end
    self.panel_list = nil

    --for k,v in pairs(self.tab_list) do
    --    if v.DeleteMe then
    --        v:DeleteMe()
    --    end
    --end
    --self.tab_list = nil
    _controller:openActionFundWindow(false)
end


--刷新上方货币
function ActionFundMainWindow:updateTopNumWealth()
    if not self.top_num_wealth_list then return end

    if self.top_num_wealth_list[1] ~= nil then
        local key = "gold"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[1].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[1].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[1].btn:setVisible(true)
    end
    if self.top_num_wealth_list[2] ~= nil then
        local key = "coin"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[2].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[2].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[2].btn:setVisible(true)
    end
    --if self.top_num_wealth_list[3] ~= nil then
    --    --if self.gw_skill_type == GuildskillConst.gw_skill_type.normal then
    --    --
    --    --else
    --    --
    --    --end
    --    local key = "guild"
    --    local key_value = role_vo[key] or 0
    --    self.top_num_wealth_list[3].value:setString(MoneyTool.GetMoneyString(key_value))
    --    local item_id = Config.ItemData.data_assets_label2id[key]
    --    local config = Config.ItemData.data_get_data(item_id)
    --    if config then
    --        local res = PathTool.getItemRes(config.icon, false)
    --        loadSpriteTexture(self.top_num_wealth_list[3].icon, res, LOADTEXT_TYPE)
    --    end
    --    self.top_num_wealth_list[3].btn:setVisible(true)
    --end
end

--更新点金红点
function ActionFundMainWindow:updataExchangeRedPoint()
    if not self.exchange_data then
        return
    end
    local red_lev_min =  Config.ConvertData.data_trade_cost.red_lev_min
    for i,v in ipairs(self.exchange_data.list) do
        if v.id == 1 and self.coin_redpoint then
            local status = false
            if (v.max - v.num) > 0 and role_vo and red_lev_min and red_lev_min.val <= role_vo.lev then
                status = true
            end
            if status == true then
                if self.coin_redpoint_spine == nil then
                    self.coin_redpoint_spine = PathTool.gw_createRedpointSpine()
                    self.coin_redpoint_spine:setPosition(40,32)
                    self.coin_redpoint:addChild(self.coin_redpoint_spine)
                end
                self.coin_redpoint_spine:setVisible(true)
                break
            else
                if self.coin_redpoint_spine then
                    self.coin_redpoint_spine:setVisible(false)
                end
            end
        end
    end
end

--创建cell
--@width 是setting.item_width
--@height 是setting.item_height
function ActionFundMainWindow:sheet_createNewCell(width, height)
    local cell = GW_GuildSkillMainWindowTabItem.new(1)
    cell:addCallBack(function() self:sheet_onCellTouched(cell) end)
    return cell
end
--获取数据数量
function ActionFundMainWindow:sheet_numberOfCells()
    if not self.sheet_list_data then return 0 end
    return #self.sheet_list_data
end
--更新cell(拖动的时候.刷新数据时候会执行次方法)
--cell :createNewCell的返回的对象
--inde :数据的索引
function ActionFundMainWindow:sheet_updateCellByIndex(cell, index)
    cell.index = index
    local guild_vo = self.sheet_list_data[index]
    cell:setData(guild_vo)
end
--点击cell .需要在 createNewCell 设置点击事件
function ActionFundMainWindow:sheet_onCellTouched(cell)
    local data = cell:getData()
    if data == nil then
        return
    end

    if data.sheet_index == self.sheet_index then
        return
    end

    self.sheet_list_data[self.sheet_index].select = false
    self.sheet_index = data.sheet_index
    self.sheet_list_data[self.sheet_index].select = true
    self.sheet_list_view:resetCurrentItems()

    self:changePanelByTab()

    local data = self.sheet_list_data[self.sheet_index].data
    if data and data.bid then
        -- 点击标签页之后购买红点消失
        if data.bid == FundType.type_one then
            _model:updateFundRedStatus(FundRedIndex.fund_buy_one, false)
        elseif data.bid == FundType.type_two then
            _model:updateFundRedStatus(FundRedIndex.fund_buy_two, false)
        end
    end
end
